#ifndef __TIMER_H__
#define __TIMER_H__

#include <stddef.h>
#include "Arduino.h"

class Timer {
  private:
    unsigned long _lastTick;
    unsigned long _currentTick;
    
    Timer() {
    }
  public:
  static Timer* getInstance() {
    static Timer* instance = new Timer();
    return instance; 
  }
  /*
  *
  */
  void initialize() {
    _lastTick = millis(); 
  }
  
  void update() {
    _currentTick = millis();
  }
  
  unsigned long delta() {
    return _currentTick - _lastTick;
  }
  
  void resetTick() {
    _lastTick = _currentTick;
  }
};

// class WorkScheduler {
//   private:
//     unsigned long _ellapsedTime;
//     unsigned long _workTime;
//     int _workPin;
//     void (*func)(int);
//   public:
//     WorkScheduler(int workPin, unsigned long time,void (*func)(int)) {
//       _workPin = workPin;
//       _workTime = time;
//       _ellapsedTime = 0;
//       this->func = func;
//     }
//     
//     ~WorkScheduler() {
//       _workPin = 0;
//       _workTime = 0; 
//       _ellapsedTime = 0;
//       func = NULL;
//     }
//     
//     void update() {
//       _ellapsedTime += Timer::getInstance()->delta();
//       if (_ellapsedTime >= _workTime) {
//         _ellapsedTime -= _workTime;
//        if (func != NULL) {
//          func(_workPin);
//        } 
//       }
//     }
// };
#endif